<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::OptimizationTarget Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1OptimizationTarget.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1OptimizationTarget-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::OptimizationTarget Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This class provides an interface specification for optimizing redundant systems.  
 <a href="classOpenSim_1_1OptimizationTarget.html#details">More...</a></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::OptimizationTarget:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1OptimizationTarget.png" usemap="#OpenSim::OptimizationTarget_map" alt=""/>
  <map id="OpenSim::OptimizationTarget_map" name="OpenSim::OptimizationTarget_map">
<area href="classOpenSim_1_1ActuatorForceTarget.html" title="A Computed Muscle Control (CMC) optimization target for controlling dynamic systems whose actuators m..." alt="OpenSim::ActuatorForceTarget" shape="rect" coords="0,112,211,136"/>
<area href="classOpenSim_1_1ActuatorForceTargetFast.html" title="A Computed Muscle Control (CMC) optimization target for controlling dynamic systems whose actuators m..." alt="OpenSim::ActuatorForceTargetFast" shape="rect" coords="221,112,432,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a731378dc81796e3ed09bccee16bd48d4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a731378dc81796e3ed09bccee16bd48d4">OptimizationTarget</a> (int aNX=0)</td></tr>
<tr class="separator:a731378dc81796e3ed09bccee16bd48d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a129e9fc55ee34e9e19e3af51caa5e549"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a129e9fc55ee34e9e19e3af51caa5e549">setNumParameters</a> (const int aNX)</td></tr>
<tr class="separator:a129e9fc55ee34e9e19e3af51caa5e549"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b9a59eb66d062d41d88e7ffdff2b672"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a6b9a59eb66d062d41d88e7ffdff2b672">setDX</a> (double aVal)</td></tr>
<tr class="separator:a6b9a59eb66d062d41d88e7ffdff2b672"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a52ea0f55facc22653fdab53bc5e38683"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a52ea0f55facc22653fdab53bc5e38683">setDX</a> (int aIndex, double aVal)</td></tr>
<tr class="separator:a52ea0f55facc22653fdab53bc5e38683"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cbd3667b9218a9de9013a331b9dcb37"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a1cbd3667b9218a9de9013a331b9dcb37">getDX</a> (int aIndex)</td></tr>
<tr class="separator:a1cbd3667b9218a9de9013a331b9dcb37"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fdf5dd2ea86e145ec77d79b58cd7bc0"><td class="memItemLeft" align="right" valign="top">double *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a4fdf5dd2ea86e145ec77d79b58cd7bc0">getDXArray</a> ()</td></tr>
<tr class="separator:a4fdf5dd2ea86e145ec77d79b58cd7bc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d5baf46187f3415d1d5459a46c5c96a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a1d5baf46187f3415d1d5459a46c5c96a">validatePerturbationSize</a> (double &amp;aSize)</td></tr>
<tr class="separator:a1d5baf46187f3415d1d5459a46c5c96a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a50a0ba65df75d0043904a453804c8e41"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a50a0ba65df75d0043904a453804c8e41">prepareToOptimize</a> (SimTK::State &amp;s, double *x)</td></tr>
<tr class="separator:a50a0ba65df75d0043904a453804c8e41"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4709e9038c473ed88b8bb3dcd840d4c"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#ac4709e9038c473ed88b8bb3dcd840d4c">printPerformance</a> (double *x)</td></tr>
<tr class="separator:ac4709e9038c473ed88b8bb3dcd840d4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a7f08da8292776b2cb834409c2a2b68c9"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a7f08da8292776b2cb834409c2a2b68c9">CentralDifferencesConstraint</a> (const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *aTarget, double *dx, const SimTK::Vector &amp;x, SimTK::Matrix &amp;jacobian)</td></tr>
<tr class="separator:a7f08da8292776b2cb834409c2a2b68c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a955bc8a7fdbe6b6619a34de01d7669b3"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a955bc8a7fdbe6b6619a34de01d7669b3">CentralDifferences</a> (const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *aTarget, double *dx, const SimTK::Vector &amp;x, SimTK::Vector &amp;dpdx)</td></tr>
<tr class="separator:a955bc8a7fdbe6b6619a34de01d7669b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a662262b4292885161905998ef41171a4"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a662262b4292885161905998ef41171a4">ForwardDifferences</a> (const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *aTarget, double *dx, const SimTK::Vector &amp;x, SimTK::Vector &amp;dpdx)</td></tr>
<tr class="separator:a662262b4292885161905998ef41171a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a819b5e73607c9462b3b719e701a30ad5"><td class="memItemLeft" align="right" valign="top">static const double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a819b5e73607c9462b3b719e701a30ad5">SMALLDX</a></td></tr>
<tr class="memdesc:a819b5e73607c9462b3b719e701a30ad5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Smallest allowable perturbation size for computing derivatives.  <a href="classOpenSim_1_1OptimizationTarget.html#a819b5e73607c9462b3b719e701a30ad5">More...</a><br /></td></tr>
<tr class="separator:a819b5e73607c9462b3b719e701a30ad5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a0fb43c9136628095d64d3e6eda808f57"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1OptimizationTarget.html#a0fb43c9136628095d64d3e6eda808f57">_dx</a></td></tr>
<tr class="memdesc:a0fb43c9136628095d64d3e6eda808f57"><td class="mdescLeft">&#160;</td><td class="mdescRight">Perturbation size for computing numerical derivatives.  <a href="classOpenSim_1_1OptimizationTarget.html#a0fb43c9136628095d64d3e6eda808f57">More...</a><br /></td></tr>
<tr class="separator:a0fb43c9136628095d64d3e6eda808f57"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>This class provides an interface specification for optimizing redundant systems. </p>
<p>If a class represents a redundant system for which one would like to find a set of optimal controls, the class should inherit from this class and implement the virtual functions defined here. </p><dl class="section author"><dt>Author</dt><dd>Frank C. Anderson </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a731378dc81796e3ed09bccee16bd48d4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a731378dc81796e3ed09bccee16bd48d4">&#9670;&nbsp;</a></span>OptimizationTarget()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::OptimizationTarget::OptimizationTarget </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aNX</em> = <code>0</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a955bc8a7fdbe6b6619a34de01d7669b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a955bc8a7fdbe6b6619a34de01d7669b3">&#9670;&nbsp;</a></span>CentralDifferences()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int OpenSim::OptimizationTarget::CentralDifferences </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *&#160;</td>
          <td class="paramname"><em>aTarget</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&#160;</td>
          <td class="paramname"><em>dx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>dpdx</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7f08da8292776b2cb834409c2a2b68c9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7f08da8292776b2cb834409c2a2b68c9">&#9670;&nbsp;</a></span>CentralDifferencesConstraint()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int OpenSim::OptimizationTarget::CentralDifferencesConstraint </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *&#160;</td>
          <td class="paramname"><em>aTarget</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&#160;</td>
          <td class="paramname"><em>dx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::Matrix &amp;&#160;</td>
          <td class="paramname"><em>jacobian</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a662262b4292885161905998ef41171a4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a662262b4292885161905998ef41171a4">&#9670;&nbsp;</a></span>ForwardDifferences()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int OpenSim::OptimizationTarget::ForwardDifferences </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a> *&#160;</td>
          <td class="paramname"><em>aTarget</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&#160;</td>
          <td class="paramname"><em>dx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">SimTK::Vector &amp;&#160;</td>
          <td class="paramname"><em>dpdx</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a1cbd3667b9218a9de9013a331b9dcb37"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1cbd3667b9218a9de9013a331b9dcb37">&#9670;&nbsp;</a></span>getDX()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double OpenSim::OptimizationTarget::getDX </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIndex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a4fdf5dd2ea86e145ec77d79b58cd7bc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4fdf5dd2ea86e145ec77d79b58cd7bc0">&#9670;&nbsp;</a></span>getDXArray()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double* OpenSim::OptimizationTarget::getDXArray </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a50a0ba65df75d0043904a453804c8e41"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a50a0ba65df75d0043904a453804c8e41">&#9670;&nbsp;</a></span>prepareToOptimize()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool OpenSim::OptimizationTarget::prepareToOptimize </td>
          <td>(</td>
          <td class="paramtype">SimTK::State &amp;&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double *&#160;</td>
          <td class="paramname"><em>x</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Reimplemented in <a class="el" href="classOpenSim_1_1ActuatorForceTargetFast.html#ae917b78498bf34c87da772b619728a30">OpenSim::ActuatorForceTargetFast</a>, and <a class="el" href="classOpenSim_1_1ActuatorForceTarget.html#aef778e3ec68d1066e8c12a89aa9e1554">OpenSim::ActuatorForceTarget</a>.</p>

</div>
</div>
<a id="ac4709e9038c473ed88b8bb3dcd840d4c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac4709e9038c473ed88b8bb3dcd840d4c">&#9670;&nbsp;</a></span>printPerformance()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void OpenSim::OptimizationTarget::printPerformance </td>
          <td>(</td>
          <td class="paramtype">double *&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a6b9a59eb66d062d41d88e7ffdff2b672"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6b9a59eb66d062d41d88e7ffdff2b672">&#9670;&nbsp;</a></span>setDX() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::OptimizationTarget::setDX </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>aVal</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a52ea0f55facc22653fdab53bc5e38683"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a52ea0f55facc22653fdab53bc5e38683">&#9670;&nbsp;</a></span>setDX() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::OptimizationTarget::setDX </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>aIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>aVal</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a129e9fc55ee34e9e19e3af51caa5e549"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a129e9fc55ee34e9e19e3af51caa5e549">&#9670;&nbsp;</a></span>setNumParameters()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::OptimizationTarget::setNumParameters </td>
          <td>(</td>
          <td class="paramtype">const int&#160;</td>
          <td class="paramname"><em>aNX</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a1d5baf46187f3415d1d5459a46c5c96a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1d5baf46187f3415d1d5459a46c5c96a">&#9670;&nbsp;</a></span>validatePerturbationSize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::OptimizationTarget::validatePerturbationSize </td>
          <td>(</td>
          <td class="paramtype">double &amp;&#160;</td>
          <td class="paramname"><em>aSize</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a0fb43c9136628095d64d3e6eda808f57"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0fb43c9136628095d64d3e6eda808f57">&#9670;&nbsp;</a></span>_dx</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt;double&gt; OpenSim::OptimizationTarget::_dx</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Perturbation size for computing numerical derivatives. </p>

</div>
</div>
<a id="a819b5e73607c9462b3b719e701a30ad5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a819b5e73607c9462b3b719e701a30ad5">&#9670;&nbsp;</a></span>SMALLDX</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const double OpenSim::OptimizationTarget::SMALLDX</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Smallest allowable perturbation size for computing derivatives. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/OptimizationTarget.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1OptimizationTarget.html">OptimizationTarget</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:28 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
